// #include "stdafx.h"
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
// #include <regex>
#ifdef WIN32
#include <Windows.h>
#endif
#include <cstdio>
using namespace std;


bool is_space(char s) {
	switch (s) {
		case '\n':
		case '\r':
		case ' ':
		case '\t':
			return true;
		default:
			return false;
	}
}
bool not_string(vector<int> poses, size_t loc) {
	int len = poses.size();
	for (int i = 0; i<len; i += 2)
		if (loc>poses[i] && loc<poses[i + 1])
			return false;
	return true;
}

void wait() {
	getchar();
}

int main(int argc, char* argv[]) {
	cout << "Designed by Mohammad Bahoosh.\nCopyright (c) by Moisrex. All rights reserved." << endl << endl;

#ifdef WIN32
	if (!argv[1]) {
		const char keyName[] = "*\\shell\\Compress (css style)\\command";
		HKEY key;
		long sts = RegOpenKeyEx(HKEY_CLASSES_ROOT, keyName, 0, KEY_READ, &key);
		if (ERROR_NO_MATCH == sts || ERROR_FILE_NOT_FOUND == sts) {
			long j = RegCreateKeyEx(HKEY_CLASSES_ROOT, keyName, 0L, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &key, NULL);
			if (ERROR_SUCCESS != j) {
				cout << "Error: Could not create registry key " << keyName << endl << "\tERROR: " << j << endl;
				if (j == 5)
					cout << "Run this program as adminstrator for once." << endl;
			}
			else
				cout << "Success: Key created." << endl;
		}
		else if (sts != ERROR_SUCCESS) {
			RegCloseKey(key);
			cout << "Unable to open registry key." << endl;
			wait();
			return 0;
		}

		char fileLoc[MAX_PATH];
		GetModuleFileName(NULL, fileLoc, MAX_PATH);
		const char* data = ("\"" + static_cast<string>(fileLoc)+"\" %1").c_str();
		long reg = RegSetValueEx(key, NULL, 0, REG_SZ, (LPBYTE)data, strlen(data)*sizeof(char));
		if (reg != ERROR_SUCCESS) {
			RegCloseKey(key);
			cout << "Unable to change registry.\nERROR: " << reg << endl;
			wait();
			return 0;
		}
		else
			cout << "From now, you can use right click context-menu to access this tool." << endl;

		RegCloseKey(key);
		wait();
		return 0;
	}
#endif

	// cout << "reading " << argv[1] << " ..." << endl;
	string code, t;
	ifstream in;
	in.open(argv[1]);
	if (!in.is_open()) {
		cout << "We don't access to that file." << endl;
		wait();
		return 0;
	}
	bool not_this_one = true;
	while (getline(in, t)) {
		code += (!not_this_one ? "\n" : "") + t;
		not_this_one = false;
	}
	in.close();

	int real_len = code.length();

	// ------- secure removing comments -------



	// regex e3("\/\\*.*?\\*\/");
	// code = regex_replace(code, e3, "");

	// find string positions
	int len = code.length(),
		found = 0;
	vector<int> positions;
	for (int i = 0; i<len; i++)
		if ((code[i] == '\'' || code[i] == '"') && (i != 0 && code[i - 1] != '\\' || i == 0))
			positions.push_back(i);

	int i = 0,
		start = -1;
	size_t found_one, found_two;
	do {
		int pos = start <= 0 ? 0 : start;
		found_one = code.find("/*", pos);
		found_two = code.find("*/", pos);
		if (found_two != string::npos && found_one != string::npos && not_string(positions, found_one)) {
			code.replace(found_one, found_two - found_one + 2, "");
			found++;
		}
		start = found_two + 1 - (found_two - found_one + 2);
		i += 2;
	}
	while (found_one != string::npos && found_two != string::npos);
	if (found > 0)
		cout << found << " comment" << (found > 1 ? "s" : "") << " removed." << endl;
	else
		cout << "no comment found." << endl;


	// ------- saving and remove strings for its safety -------
	vector<string> strings;
	size_t c;
	char lastChar = '.';
	int pos = -1;
	do {
		pos++;
		if (lastChar == '\'') {
			c = code.find("\'", pos);
			lastChar = ' ';
		}
		else if (lastChar == '"') {
			c = code.find("\"", pos);
			lastChar = ' ';
		}
		else {
			size_t c1, c2;
			c1 = code.find("\'", pos);
			c2 = code.find("\"", pos);
			c = c1>c2 ? c2 : c1;
			lastChar = c1 > c2 ? '"' : '\'';
		}
		int p = pos;
		int backslashes = 0;
		while (p--)
			if (code[p] != '\\')
				break;
			else
				backslashes++;
		if (backslashes % 2 != 0) {
			pos = c;
			continue;
		}
		if (c == string::npos)
			break;
		if (c != string::npos && lastChar == ' ') {
			strings.push_back(code.substr(pos, c - pos));
			code.replace(pos, c - pos, "");
			c -= c - pos;
		}
		pos = c;
	}
	while (true);
	int v_len = strings.size();
	if (v_len > 0)
		cout << v_len << " string" << (v_len > 1 ? "s" : "") << " still untouched." << endl;
	else
		cout << "no string found." << endl;


	found = 0;
startover:

	int not_real_len = code.length();


	// ------- removing useless charachters -------

	// regex e1("\\s{2,}");
	// code = regex_replace(code, e1, " ");
	len = code.length();
	i = 0;
	do {
		bool is = is_space(code[i]);
		if (
			(i + 1 < len && is && is_space(code[i + 1])) ||
			(i + 1 == len && is) ||
			(i == 0 && is) ||
			(i != 0 && code[i - 1] == ';' && is) ||
			(i != len - 1 && code[i + 1] == ';' && is) ||
			(i != 0 && code[i - 1] == ':' && is) ||
			(i != len - 1 && code[i + 1] == ':' && is) ||
			(i != 0 && code[i - 1] == '{' && is) ||
			(i != len - 1 && code[i + 1] == '{' && is) ||
			(i != 0 && code[i - 1] == '}' && is) ||
			(i != len - 1 && code[i + 1] == '}' && is) ||
			(i != 0 && code[i - 1] == '(' && is) ||
			(i != len - 1 && code[i + 1] == '(' && is) ||
			(i != 0 && code[i - 1] == ')' && is) ||
			(i != len - 1 && code[i + 1] == ')' && is) ||
			(i != 0 && code[i - 1] == ',' && is) ||
			(i != len - 1 && code[i + 1] == ',' && is) ||
			(i != 0 && code[i - 1] == '/' && is) ||
			(i != len - 1 && code[i + 1] == '/' && is) ||
			(i != len - 1 && code[i] == ';' && code[i + 1] == '}') ||
			(i != 0 && code[i] == ';' && code[i - 1] == ';')
			) {
			code.replace(i, 1, "");
			found++;
			len--;
		}
		else
			i++;
		len = code.length();
	}
	while (i < len);

	if (not_real_len != len)
		goto startover;

	if (found > 0)
		cout << found << " useless charachter" << (found > 1 ? "s" : "") << " removed." << endl;
	else
		cout << "no useless charachter found." << endl;


	// regex e2("\\s?([,\\)\\(\\:;\\}\\{])\\s?");
	// code = regex_replace(code, e2, "$1");

	// ------- replace strings -------
	int last_pos = 0;
	for (int i = 0; i<v_len; i++) {
		// find first:
		size_t pos1 = code.find("''", last_pos);
		size_t pos2 = code.find("\"\"", last_pos);
		size_t chars = pos2>pos1 ? pos1 : pos2;

		last_pos = pos2 + 1 + strings[i].length();
		code.replace(chars + 1, 0, strings[i]);
	}
	// if(v_len > 0)
	// 	cout << v_len << " string" << (v_len>1?"s":"") << " replaced" << endl;
	// else
	// 	cout << "there is no string to replace" << endl;


	int reduce = real_len - code.length();
	if (reduce != 0) {
		cout << "total: " << reduce << " useless charachter" << (reduce>1 ? "s" : "") << " removed." << endl;
		cout << reduce * 100 / real_len << "% compressed." << endl;
		ofstream out;
		out.open(argv[1]);
		if (!out.is_open()) {
			cout << "we couldn't access the file again." << endl;
		}
		out << code;
		out.close();
	}
	else
		cout << "there is nothing to change." << endl;

	// cout << code << endl;
	wait();
}

